/* $Id: user.c 125 2023-08-06 19:30:08Z nishi $ */
#include <swinehub/user.h>

#include <swinehub.h>
#include <swinehub/config.h>
#include <swinehub/repo.h>
#include <swinehub/util.h>
#include <swinehub/language.h>
#include <swinehub/db.h>

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>

EXTERN_DB;

void swinehub_user(struct swinehub_config* config){
	if(swinehub_check_repo(config) != 1){
		printf("User does not exist.\n");
	}else{
		char* user_or_team = NULL;
		swinehub_db_init();
		datum key;
		key.dptr = getenv("PATH_REPLACED") + 2;
		key.dsize = strlen(getenv("PATH_REPLACED") + 2) + 1;
		datum user = dbm_fetch(swinehub_user_db, key);
		struct swinehub_user* s_user = (struct swinehub_user*)user.dptr;
		if(s_user->isteam == 1){
			user_or_team = strdup(SW_TEAM);
		}else{
			user_or_team = strdup(SW_USER);
		}
		SW_USER_TITLE;
		printf("<hr>\n");
		if(s_user->isteam == 1){
			printf("<div id=\"team-manager\" style='display: none;'>\n");
			printf("	<table border='0' class='widthfloat box'>\n");
			printf("		<thead>\n");
			printf("			<th style='width: 100%%;'>" SW_USERNAME "</th>");
			printf("			<th style='min-width: 250px;'>" SW_CONTROL "</th>");
			printf("		</thead>\n");
			printf("		<tbody id=\"swinehub-users-table\">\n");
			FILE* f = fopen(SWINEHUB_AUTHZ, "r");
			flockfile(f);
			char* buf = malloc(1);
			buf[0] = 0;
			char* readbuf = malloc(2);
			readbuf[1] = 0;
			char* find = sstrcat("#%START-TEAM ", getenv("PATH_REPLACED") + 2);
			char found = 0;
			while(1){
				fread(readbuf, 1, 1, f);
				if(readbuf[0] == '\n' || feof(f)){
					if(found == 1){
						char* users = buf + strlen(getenv("PATH_REPLACED") + 2) + 3;
						printf("<input type=\"hidden\" value=\"%s\" id=\"swinehub-team-users\" autocomplete=\"off\">\n", users);
						char* userbuf = malloc(1);
						userbuf[0] = 0;
						char* ruserbuf = malloc(2);
						ruserbuf[1] = 0;
						int i = 0;
						if(users[i] != 0){
							while(1){
								if(users[i] == ',' || users[i] == 0){
									printf("<tr>\n");
									printf("	<td>%s</td>\n", userbuf);
									printf("	<td>\n");
									printf("		<input type=\"checkbox\" style=\"appearance: checkbox;\" id=\"kick_checkbox_%s\" checked=\"false\"> " SW_KICK "\n", userbuf);
									printf("	</td>\n");
									printf("</tr>\n");
									free(userbuf);
									userbuf = malloc(1);
									userbuf[0] = 0;
									if(users[i] == 0) break;
								}else{
									ruserbuf[0] = users[i];
									char* tmp = userbuf;
									userbuf = sstrcat(tmp, ruserbuf);
									free(tmp);
								}
								i++;
							}
						}
						free(userbuf);
						free(ruserbuf);
						break;
					}
					if(strcmp(buf, find) == 0){
						found = 1;
					}
					free(buf);
					buf = malloc(1);
					buf[0] = 0;
					if(feof(f)) break;
				}else{
					char* tmp = buf;
					buf = sstrcat(buf, readbuf);
					free(tmp);
				}
			}
			free(find);
			free(readbuf);
			free(buf);
			funlockfile(f);
			fclose(f);
			printf("		<tr id=\"swinehub-new-user-element\">\n");
			printf("			<td>\n");
			printf("				<input id=\"new-username\" style=\"width: 90%%;\">");
			printf("			</td>\n");
			printf("			<td>\n");
			printf("				<input type=\"button\" value=\"" SW_ADD "\" onclick=\"swinehub_add()\">\n");
			printf("			</td>\n");
			printf("		</tr>\n");
			printf("		</tbody>\n");
			printf("	</table>\n");
			printf("	<div class=\'widthfloat\'>\n");
			printf("		<button onclick=\"swinehub_apply()\">" SW_APPLY "</button>\n");
			printf("	</div>\n");
			printf("	<hr>\n");
			printf("</div>\n");
		}
		int count = 0;
		DIR* dir = opendir(config->path);
		char* result = malloc(1);
		result[0] = 0;
		if(dir != NULL){
			struct dirent* d;
			char* cmp = sstrcat(getenv("PATH_REPLACED") + 2, "-");
			while((d = readdir(dir)) != NULL){
				if(strcmp(d->d_name, ".") == 0 || strcmp(d->d_name, "..") == 0) continue;
				if(strlen(d->d_name) < strlen(cmp)) continue;
				char* tmp = strdup(d->d_name);
				tmp[strlen(cmp)] = 0;
				if(strcmp(tmp, cmp) == 0){
					char* tmpstr = result;
					char* name = sstrcat4("~", getenv("PATH_REPLACED") + 2, "/", d->d_name + strlen(cmp));
					char* link = sstrcat3(getenv("SCRIPT_NAME"), "/", name);
					char* content = sstrcat3(user_or_team, "</span><b>/</b><span>", name);
					result = sstrcat6(tmpstr, "<a href=\"", link, "\"><span>",  content, "</span></a>\n");
					free(link);
					free(name);
					free(content);
					count++;
				}
				free(tmp);
			}
			free(cmp);
			closedir(dir);
		}
		SW_USER_HAS;
		printf("<div id='repositories' class='widthfloat'>\n");
		printf("%s\n", result);
		printf("</div>\n");
		free(result);
		free(user_or_team);
		swinehub_db_close();
	}
}
